




function  Loss = Loss_fun_cs(opt_weights1)


global beta sigma gamma eta zetaZAlpha SIGMA_SS an_vec alpha_vec lambda_vec theta_vec dimK NF N G sel rho_cts%D W_mat F


 
if sel == 2
 
 opt_weights = [0; exp(opt_weights1(1:8));1; exp(opt_weights1(9:end))]; %% this sets the weight on output gap == 0
opt_weights
else 
    
 opt_weights = [0;opt_weights1; 1-opt_weights1];
 

end
 
 

%% Constructs matrces for REds, solds and Weighting matrix


[A, B, C, kAlphaR, kAlphaC, kAlphaZ, dimK, W_mat] =...
    param_natural_target6_cs(N, sigma,  beta, gamma, theta_vec, eta,...
    alpha_vec, lambda_vec, zetaZAlpha, opt_weights,an_vec,rho_cts);

      
%% Solves REE for given weights
  [Br,Cr,Lr,NF,er_s] = redsf(A,B,C,size(A,1),size(C,2),dimK);
  
  
  
  if er_s == 0   %% makes sure there are no errors
      
   [D,F,G,H,er_d] = soldsf(Br,Cr,Lr,size(A,1),size(C,2),dimK, NF);

  
  else er_d = 1;
   
      
  end
  
  
   
   if er_d == 0
   
  
     %% Transform vector y to include relative prices and shocks at time t

 
      D(size(D,1)-dimK+1:end,:) = G;
      
      F(size(D,1)-dimK+1:end,:) = H; 
      
    
      D = real(D); F = real(F); G = real(G); H = real(H);

      
%   disp('REDS solds done')
  
  %% Computes the Loss


%% Compute first variance-covariance of the state vector


% disp('sk')
SIGMAK = vcv(SIGMA_SS, G, H);
% disp('end sk')





WD = D'*W_mat*D; %% transforms the weights matrix


%% Solves Sylvester equation

L_S = sylvester(WD,G',G,beta);


Loss1a = trace(beta*L_S*H*SIGMA_SS*H');

Loss1b = trace((1-beta)*L_S*SIGMAK);

Loss2 = trace(F'*W_mat*F*SIGMA_SS);
 



Loss = (1-beta)^(-1)*(Loss1a+Loss1b+Loss2);


  else
      
      Loss = 10000000000000000000000000000000000000000;


  end %% closes er_s loop
  
  


